Submit | All submissions | Best solutions | Back to list |
PPATH - Prime Path |
The ministers of the cabinet were quite upset by the
message from the Chief of Security stating that they
would all have to change the four-digit room numbers
on their offices.
— It is a matter of security to change such things
every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good
reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also
a prime. You will just have to paste four new
digits over the four old ones on your office door.
— No, it's not that simple. Suppose that I change the
first digit to an 8, then the number will read 8033
which is not a prime!
— I see, being the prime minister you cannot stand
having a non-prime number on your door even for a
few seconds.
— Correct! So I must invent a scheme for going from
1033 to 8179 by a path of prime numbers where
only one digit is changed from one prime to the
next prime.
Now, the minister of finance, who had been eavesdropping,
intervened.
— No unnecessary expenditure, please! I happen to
know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to
minimize the cost. You don't know some very cheap
software gurus, do you?
— In fact, I do. You see, there is this programming
contest going on...
Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033 1733 3733 3739 3779 8779 8179The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Example
Input: 3 1033 8179 1373 8017 1033 1033 Output: 6 7 0
Added by: | overwise |
Date: | 2007-10-02 |
Time limit: | 2s |
Source limit: | 50000B |
Memory limit: | 1536MB |
Cluster: | Cube (Intel G860) |
Languages: | All except: ERL JS-RHINO NODEJS PERL6 VB.NET |
Resource: | ACM ICPC NWERC 2006 |
hide comments
|
||||||||||||||
2018-12-03 16:04:08
test files are weak :(( |
||||||||||||||
2018-11-30 08:05:29
50th ; 0.00 27M Last edit: 2018-11-30 08:05:56 |
||||||||||||||
2018-11-21 08:56:55
Awesome problem, got AC in first try. Took an hour to code it :( |
||||||||||||||
2018-09-27 10:44:37
AC in a go. bfs +implementation |
||||||||||||||
2018-09-21 04:49:00
Nice problem easy bfs AC with 0.01s |
||||||||||||||
2018-09-11 10:56:25
easy bfs 0.07 |
||||||||||||||
2018-08-31 08:27:47 tanardi gunawan
easy problem using string ac in 0,19s!!! |
||||||||||||||
2018-08-24 13:11:26
Pretty Straightforward problem wasted 3 hours trying different implementation for calculating shortest distance but error was in logic to check 'one digit difference' between prime numbers; *ultimate facepalm moment* but still AC in 1 go :P |
||||||||||||||
2018-07-26 18:36:20
Good bfs problem. Store the sieve of prime numbers beforehand so you dont have to calculate all the prime numbers for every test case. |
||||||||||||||
2018-06-30 08:26:10
OMG this problem...I don't know about you guys but this was a really nice problem. The bfs,graph,sieve and concept was really good. I was getting WA even though all my answers were correct but there was one testcase which was not giving correct ans...I dont know why, After hitting walls for few hours I replaced the memset with loop and got AC.If you want to know the test case..this was the one- 3 4241 6101 5099 7159 1559 9437 Correct ans- 5 5 4 My ans was- 5 5 5 And lastly I though I will be getting TLE but we have big enough time space. |